<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>{{ title }}</title>
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <!-- <meta http-equiv="refresh" content="5" />  每 content 秒網頁自動更新-->

    <!-- 新 Bootstrap4 核心 CSS 文件 -->
    <link rel="stylesheet" href="https://cdn.bootcss.com/bootstrap/4.1.0/css/bootstrap.min.css">
    <!-- jQuery文件。务必在bootstrap.min.js 之前引入 -->
    <script src="https://cdn.bootcss.com/jquery/3.2.1/jquery.min.js"></script>
    <!-- popper.min.js 用于弹窗、提示、下拉菜单 -->
    <script src="https://cdn.bootcss.com/popper.js/1.12.5/umd/popper.min.js"></script>
    <!-- 最新的 Bootstrap4 核心 JavaScript 文件 -->
    <script src="https://cdn.bootcss.com/bootstrap/4.1.0/js/bootstrap.min.js"></script>
    <!--可用來建立使用者小圖示-->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script language="JavaScript">
        // 指定 秒 刷新網頁一次
        var ftn = '{{tid}}';
        var status = '{{status}}';
        console.log('ftn:' + ftn)

        $(function(){
            $("#ferment_input_page").text('發酵貨櫃入料儲豆槽 FI' + ftn + ' 攝影機畫面   ')
            $('#ferment_input_page').attr("href", "/camera_FI" + ftn)
            $("#ferment_input_title").text('發酵貨櫃入料儲豆槽 FI' + ftn + ' 操作介面')
            $("#coffee_title_pc").text('FI' + ftn + ' 發酵入料儲豆槽操作介面');
            $("#coffee_title_phone").text('FI' + ftn + ' 操作介面');

            if (status == 2) {
                $('input').prop('disabled', true);
                $('button').prop('disabled', true);
            } else if ( (status == 0) || (status == 1) ) {
                $('input').prop('disabled', false);
                $('button').prop('disabled', false);   
            }
        });

        WebUpdate_set = setInterval(function(){WebUpdate(ftn)} , 10 * 1000)
    </script>

    <script>
        // 發酵槽_制動器控制
        var tank_num = '{{tid}}';

        function inputVacuum() {
            var status = "off";
            var check = $("input[name=input_vacuum_status]:checked");  // 這裡面是 jQuery 撈取資料的方法, jQuery 常使用到 $ 錢字號
            console.log('check：', check);
            //大於0代表有被選中, 如果有多個可以呈現勾取的項目數量
            if (check.length > 0) {
                status = "on";
                $("#cmn-toggle-02").prop('checked', false); // 確認是否勾選
                if (!confirm("你確定要開啟入料儲豆槽真空吸料機嗎?")) {
                    return false;
                };
            } else {
                $("#cmn-toggle-02").prop('checked', true);
                if (!confirm("你確定要關閉入料儲豆槽真空吸料機嗎?")) {
                    return false;
                };
            };

            var data = { "tank_num": "FI" + tank_num, "command": "input_vacuum_status", "value": status };
            $.post('/mqtt/{{tid}}', data, function (res) {
                console.log('data:', data)
                if (res == 'on') {
                    $("#cmn-toggle-02").prop('checked', true);
                    setTimeout("alert('入料儲豆槽真空吸料機_開啟成功!')", 500);
                } else if (res == 'off') {
                    $("#cmn-toggle-02").prop('checked', false);
                    setTimeout("alert('入料儲豆槽真空吸料機_關閉成功!')", 500);
                } else {
                    alert(res);
                };
            }, 'text')
        };

        function inputVacuum(params) {
            if (params == '1') {
                var data = { "tank_num": "FI" + tank_num, "command": "input_vacuum_status", "value": "on" };
            } else if (params == '0') {
                var data = { "tank_num": "FI" + tank_num, "command": "input_vacuum_status", "value": "off" };
            } else {
                var data = { "tank_num": "FI" + tank_num, "command": "input_vacuum_status", "value": params };
            }
            $.post('/mqtt/{{tid}}', data, function (res) {      //res：HTTP response argument to the middleware function
                console.log('data:', data)
                if (res == 'on') {
                    $("#cmn-toggle-02").prop('checked', true);
                } else if (res == 'off') {
                    $("#cmn-toggle-02").prop('checked', false);
                } else {
                };
            }, 'text')
        };

    </script>
    
    <script language="JavaScript">
            
        function changeUpdate() {
            clearInterval(WebUpdate_set);

            var webupdate_time = $("input[name=webupdate_time]").val()
            console.log('webupdate_time' + webupdate_time)
            WebUpdate_set = setInterval(function(){WebUpdate(ftn)} , webupdate_time * 1000);
        }

        // jQuery 更新感測器制動器狀態
        function WebUpdate(ftn) {
            $.get('/loading/FI' + ftn, '', function (res) {
                if (res.input_vacuum == 0) {
                    $("#cmn-toggle-02").prop('checked', false);
                } else if (res.input_vacuum == 1) {
                    $("#cmn-toggle-02").prop('checked', true);}


                    $("#UltraSonic_t_status").text(res.input_UltraSonic);
    
            }, 'json');
        }
    </script>
</head>

<body>
    <div id="wrapper">
        <div id="coffee_header">
            <!-- 匯入共同使用的 header.html 內容 -->
            {% include 'header.html' %}
        </div>


        <h4>制動器</h4>
        <table border="1" class="table-all" cellpadding="5" style="text-align: center;">
            <tr>
                <td style="color:red;">Valve</td>
                <td>真空吸料機</td>
            </tr>
            <tr>
                <td>
                    <span style="color:#C0C0C0;">off</span>
                    <span style="color:#008CBA;">on</span>
                </td>
                <td>
                    <div class="switch_div">
                        <div class="switch">
                            <input type="checkbox" class="cmn-toggle cmn-toggle-round" id="cmn-toggle-01">
                        </div>
                        <div class="switch text-center">
                            {% if input_vacuum == 1 %}
                            <input type="checkbox" class="cmn-toggle cmn-toggle-round-flat" id="cmn-toggle-02" checked
                                name="tank_vacuum_status" value="ON" onclick="inputVacuum()">
                            {% else %}
                            <input type="checkbox" class="cmn-toggle cmn-toggle-round-flat" id="cmn-toggle-02"
                                name="tank_vacuum_status" value="OFF" onclick="inputVacuum()">
                            {% endif %}
                            <label class="label_ActuatorStatus" for="cmn-toggle-02"></label>
                        </div>
                        <div class="switch">
                            <input type="checkbox" class="cmn-toggle cmn-toggle-yes-no" id="cmn-toggle-03">
                        </div>
                    </div>
                </td>
            </tr>
            <tr>
                <td><span style="color:#008CBA;"><b>ON</b></span></td>
                <td><input type="button" class="input-button-on" value="ON" onclick="inputVacuum('1')"></td>
            </tr>
            <tr>
                <td><span style="color:#C0C0C0;"><b>OFF</b></span></td>
                <td><input type="button" class="input-button-off" value="OFF" onclick="inputVacuum('0')"></td>
            </tr>
        </table>

        <br>

        <h4>感測器</h4>
        <table border="1" class="table-all" cellpadding="5">
            <tr>
                <td>生豆高度：<span id="UltraSonic_t_status">{{input_UltraSonic.UltraSonic}}</span> 公分</td>
            </tr>
        </table>

        <br>

        <h4>排程設計</h4>
        <table border="1" class="table-all" cellpadding="5">
            <tr>
                <td>入料</td>
                <td>循環測試</td>
            </tr>
            <tr>
                <td>
                    指定桶內生豆高度
                    <input type="text" class="input-text" name="testing_BeanIn_Height" value="0">公分<br>
                    吸料時間
                    <input type="text" class="input-text" name="testing_in_vacuum_in" value="5">秒<br>
                    放料時間
                    <input type="text" class="input-text" name="testing_in_vacuum_out" value="10">秒<br>
                    循環次數
                    <input type="text" class="input-text" name="testing_in_vacuum_loop" value="3">次<br>
                </td>
                <td>
                    ON (開)
                    <input type="text" class="input-text" name="Testing_starttime" value="3">秒<br>
                    OFF (關)
                    <input type="text" class="input-text" name="Testing_endtime" value="5">秒<br>
                    循環
                    <input type="text" class="input-text" name="Testing_loop" value="3">次
                </td>
            </tr>
            <tr>
                <td>
                    <button type="submit" class="btn btn-primary" onclick="CoffeeIn_testing()">入豆測試</button>
                    <script>
                        CoffeeIn_Process = 0;   // 生豆入豆狀態
                        function CoffeeIn_testing() {
                            var testing_tank_coffee_height = $("input[name=testing_tank_coffee_height]").val();
                            console.log('目標入料高度' + testing_tank_coffee_height)

                            var testing_tank_vacuum_in = $("input[name=testing_tank_vacuum_in]").val();
                            var testing_tank_vacuum_out = $("input[name=testing_tank_vacuum_out]").val();
                            var testing_tank_vacuum_loop = $("input[name=testing_tank_vacuum_loop]").val();

                            if (testing_tank_coffee_height != 0) {
                                console.log('以目標高度入豆')

                                var Coffee_interval = setInterval(tankCoffeeHeight, 5000);

                                function tankCoffeeHeight(){
                                    if (CoffeeIn_Process == 1){
                                        return;
                                    }
                                    
                                    CoffeeIn_Process = 1;
                                    $.ajax({
                                        async:false,
                                        type:'GET',
                                        url:'/ferment_LiDAR_' + tank_num,
                                        dataType:'JSON',
                                        success:function(response){
                                            var present_Coffee_height = response.LiDAR
                                            console.log("目前生豆高度: ", present_Coffee_height)

                                            if( present_Coffee_height >= testing_tank_coffee_height){
                                                clearInterval(Coffee_interval);
                                                console.log("生豆已達目標高度！")
                                                CoffeeIn_Process = 0;
                                            } else {
                                                inputVacuum('1')
                                                console.log('inputVacuum_ON')

                                                var time = new Date();
                                                while ((new Date() - time) < testing_tank_vacuum_in * 1000) { };

                                                inputVacuum('0')
                                                console.log('inputVacuum_OFF')

                                                var time = new Date();
                                                while ((new Date() - time) < testing_tank_vacuum_out * 1000) { };
                                                CoffeeIn_Process = 0;
                                            }
                                        },
                                        error:function(thrownError){
                                            console.log("Error: " + thrownError)
                                            CoffeeIn_Process = 0;
                                        }
                                    });
                                    CoffeeIn_Process = 0;
                                };

                                
                            } else if (testing_tank_coffee_height == 0){
                                console.log('開始循環入豆')

                                for (step = 1; step <= testing_tank_vacuum_loop; step++) {
                                    console.log('-- 循環第 ' + step + ' 次 --');

                                    inputVacuum('1')
                                    console.log('inputVacuum_ON')

                                    var time = new Date();
                                    while ((new Date() - time) < testing_tank_vacuum_in * 1000) { };

                                    inputVacuum('0')
                                    console.log('inputVacuum_OFF')

                                    var time = new Date();
                                    while ((new Date() - time) < testing_tank_vacuum_out * 1000) { };
                                }

                                console.log('-- 循環入豆結束 --')

                            }
                        }
                    </script>
                </td>
                <td>
                    <button type="submit" class="btn btn-primary" onclick="tankVacuumTest()">真空吸料機測試(秒)</button><br>
                    <script>
                        function tankVacuumTest() {
                            clearInterval(WebUpdate_set);
                            var Testing_starttime = $("input[name=Testing_starttime]").val();
                            var Testing_endtime = $("input[name=Testing_endtime]").val();
                            var Testing_loop = $("input[name=Testing_loop]").val();
                            alert('測試間隔' + Testing_starttime + ':' + Testing_endtime + ' 次數' + Testing_loop)
                            var step;

                            for (step = 1; step <= Testing_loop; step++) {
                                console.log('循環第 ' + step + ' 次');

                                inputVacuum('1')
                                console.log('inputVacuum_ON')

                                var time = new Date();
                                while ((new Date() - time) < Testing_starttime * 1000) { }

                                inputVacuum('0')
                                console.log('inputVacuum_OFF')

                                var time = new Date();
                                while ((new Date() - time) < Testing_endtime * 1000) { }
                            }
                            WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , 10 * 1000);
                        }
                    </script>
                </td>
            </tr>
        </table>

        <div id="coffee_footer">
            <!-- 匯入共同使用的 footer.html 內容 -->
            {% include 'footer.html' %}
        </div>
    </div>
    
</body>

</html>